Table of contents
Access Control
This API is deprecated. Please upgrade to the current version of this API as soon as possible.
POST https://api.bentley.com/accesscontrol/itwins/{id}/members

Add new iTwin members

Authentication

Requires Authorization header with valid Bearer token for scope itwin-platform.

For more documentation on authorization and how to get access token visit OAUTH2 Authorization page.

Authorization

User must have the administration_invite_member permission assigned at the iTwin level or be an Organization Administrator for the Organization that owns a given iTwin.

An Organization Administrator must have at least one of the following roles assigned in User Management: Account Administrator, Co-Administrator, or CONNECT Services Administrator. For more information about User Management please visit our Bentley Communities Licensing, Cloud, and Web Services wiki page.

Request parameters

Name
Required?
Description
id
Yes

The iTwin ID

Request headers

Name
Required?
Description
Authorization
Yes

OAuth access token with itwin-platform scope

Accept
Yes

Setting to application/vnd.bentley.itwin-platform.v1+json is recommended.

Request body

Members (add by email)

Name
Type
Required?
Description
members
No

List of members.

Example

json
{
    "members": [{
        "email": "John.Johnson@example.com",
        "roleId": "5abbfcef-0eab-472a-b5f5-5c5a43df34b1"
    }, {
        "email": "Maria.Miller@example.com",
        "roleId": "5abbfcef-0eab-472a-b5f5-5c5a43df34b1"
    }]
}

Response 201 Created

iTwin member was successfully added.

json
{
    "members": [{
        "id": "99cf5e21-735c-4598-99eb-fe3940f96353",
        "email": "John.Johnson@example.com",
        "givenName": "John",
        "surname": "Johnson",
        "organization": "Organization Corp.",
        "roles": [{
            "id": "5abbfcef-0eab-472a-b5f5-5c5a43df34b1",
            "displayName": "Read Access",
            "description": "Read Access"
        }]
    }, {
        "id": "25407933-cad2-41a2-acf4-5a074c83046b",
        "email": "Maria.Miller@example.com",
        "givenName": "Maria",
        "surname": "Miller",
        "organization": "Organization Corp.",
        "roles": [{
            "id": "5abbfcef-0eab-472a-b5f5-5c5a43df34b1",
            "displayName": "Read Access",
            "description": "Read Access"
        }]
    }]
}

Response 401 Unauthorized

This response indicates that request lacks valid authentication credentials. Access token might not been provided, issued by the wrong issuer, does not have required scopes or request headers were malformed.

json
{
    "error": {
        "code": "HeaderNotFound",
        "message": "Header Authorization was not found in the request. Access denied."
    }
}

Response 403 Forbidden

The user has insufficient permissions for the requested operation.

json
{
    "error": {
        "code": "InsufficientPermissions",
        "message": "The user has insufficient permissions for the requested operation."
    }
}

Response 404 Not Found

This response indicates that iTwin or user member with specified ID was not found.

json
{
    "error": {
        "code": "ItwinNotFound",
        "message": "Requested iTwin is not available."
    }
}

Response 409 Conflict

Invalid request to add new iTwin member. Member already exists in iTwin.

json
{
    "error": {
        "code": "TeamMemberExists",
        "message": "Requested team member already exists in iTwin.",
        "target": "members[0].email"
    }
}

Response 422 Unprocessable Entity

Invalid request to add new iTwin member. Request payload might be missing some of the required properties.

json
{
    "error": {
        "code": "InvalidiTwinsMemberRequest",
        "message": "Request body or query is invalid.",
        "details": [{
            "code": "MissingRequiredProperty",
            "message": "Required property is missing.",
            "target": "members[0].email"
        }, {
            "code": "MissingRequiredProperty",
            "message": "Required property is missing.",
            "target": "members[0].roleId"
        }, {
            "code": "InvalidProperty",
            "message": "Collection size exceeds maximum size.",
            "target": "members"
        }, {
            "code": "InvalidRequestBody",
            "message": "Failed to parse request body or collection is empty."
        }]
    }
}

Response 429 Too many requests

This response indicates that the client sent more requests than allowed by this API for the current tier of the client.

json
{
    "error": {
        "code": "RateLimitExceeded",
        "message": "The client sent more requests than allowed by this API for the current tier of the client."
    }
}

Response headers

Name
Description
retry-after

Number of seconds to wait until client is allowed to make more requests.

Error

Contains error information.

Name
Type
Description
code
String

One of a server-defined set of error codes.

message
String

A human-readable representation of the error.

target
String, null

The target of the error.

Error Response

Gives details for an error that occurred while handling the request. Note that clients MUST NOT assume that every failed request will produce an object of this schema, or that all of the properties in the response will be non-null, as the error may have prevented this response from being constructed.

Name
Type
Description
error

Role

Name
Type
Description
id
String

The role id.

displayName
String

The display name of your Role.

description
String

A description of your Role.

permissions
String[]

List of permissions assigned to the role.

iTwin Member

Name
Type
Description
id
String

The user Id in Identity Management System.

email
String

User email.

givenName
String

User given name.

surname
String

User surname.

organization
String

Organization user is member of in Identity Management System.

roles

List of roles.

link

Hyperlink container.

Name
Type
Description
href
String

Hyperlink container.

links (paging)

URLs for redoing the current request, getting to the previous or next page of results, if applicable containg.

Name
Type
Description
self
next
prev

iTwin Members

Name
Type
Description
members

List of members.

Member (add by email)

Name
Type
Description
email
String

User email.

roleId
String

Id of the role

Members (add by email)

Name
Type
Description
members

List of members.

Was this page helpful?